$(document).ready(function() {
    
    localStorage.cajaAbierta = 'false';

    $('#modal1').modal({
        "dismissible": false
    });


    $("#modal-title").html('Confirmarcio&#769;n');
    $("#divModalContent").html('');

    createNumPad('divModalContent', 'confirmPSW', 'confirm', '', '');
    $("#divModalContent").append(`<input type='text' id="confirmPSW" style="display:none;">`);
    
    $('#modal1').modal('open');

});

function returnCaja(){
    window.location = "main.html";
}

function autenticado(){
    localStorage.cajaAbierta = 'true';
    $('#modal1').modal('close');
    $('#btnCloseModal').removeClass("modal-close-alt");
    $('#btnCloseModal').removeAttr("onclick");
    $('#btnCloseModal').addClass("modal-close");

    $('#input0').css('border-bottom-color', '#ffb300');
    $('#input0').css('background-color', '#ffecb3');

    $(".monedas").change(function() {
        let monto = $(this).val();
        let value = $(this).attr('title');
        let total = (accounting.formatNumber(monto, 2) * accounting.formatNumber(value, 2));
        if (isNaN(total)) {
            total = 0;
        }
        $("#result" + value).val(accounting.formatNumber(total, 2));

        let totalEfectivo = 0;
        $(".totalesM").each(function() {
            totalEfectivo = parseFloat(totalEfectivo) + parseFloat($(this).val());
            $("#totalEfectivo").val(accounting.formatNumber(totalEfectivo, 2));
        });
    });

    createNumPad('divNumPad','input0','.','arrow-up','arrow-down');
    
    
    sunmiInnerPrinter.openDrawer();
    //alert('se abriio');
}

function getDetalleVentas(){
    params = {
        service: 'getDetalleVentas',
        dbName: dbName,
        idSucursales: localStorage.idSucursales,
        idUsuarios: localStorage.idUsuarios,
        idEmpresas: localStorage.idEmpresas
    };
    //
    $.post(host, params, function(data) {
        procesarCorte(data);
        
    }, 'json');
}

function procesarCorte(detVentas) {

    var cantidad = [];
    var descripcion = [];
    var detalle = [];

    $(".cantidad").each(function(index) {
        cantidad.push(accounting.formatNumber($(this).val(), 2));
        descripcion.push($(this).attr('title'));
    });

    $(".totalesM").each(function(index) {
        var arr = {};
        arr['cantidad'] = accounting.unformat(cantidad[index]);
        arr['descripcion'] = descripcion[index];
        arr['total'] = accounting.formatNumber($(this).val(), 2);
        detalle.push(arr);
    });
    params = {
        service: 'procesarCorte',
        totalEfectivo: accounting.formatNumber($("#totalEfectivo").val(), 2),
        detalle: detalle,
        dbName: dbName,
        idSucursales: localStorage.idSucursales,
        idUsuarios: localStorage.idUsuarios,
        idEmpresas: localStorage.idEmpresas
    };
    //
    $.post(host, params, function(data) {
        $.each(data, function(key, val) {
            if (val.message === 'success') {
                
                printCorte(val, detVentas);
                
            } else {
                $('#loader').hide();
                Swal.fire({
                    icon: 'error',
                    title: val.message,
                    showCloseButton: true,
                    confirmButtonText: 'Intentar de nuevo'
                });
            }
        });
    }, 'json');
}

function corteDeCaja() {
    $("#modal-title").html('Confirmarcio&#769;n');
    $("#divModalContent").html('');

    createNumPad('divModalContent', 'confirmPSW', 'confirm', '', '');
    $("#divModalContent").append(`<input type='text' id="confirmPSW" style="display:none;">`);
    
    $('#modal1').modal('open');   
}

function confirmado(){
    if(localStorage.cajaAbierta == 'true'){
        getDetalleVentas();
    }
    else{
        autenticado();
    }
    $('#loader').hide();
}

function printCorte(detCorte, detVentas){
    localStorage.cajaAbierta = 'false';

    var tamano = [col3A,col3B,col3B];
    var alineamiento = [0, 2, 2];

    sunmiInnerPrinter.enterPrinterBuffer(true);

    sunmiInnerPrinter.setAlignment(1);
    sunmiInnerPrinter.printTextWithFont("CORTE DE CAJA\n" + detCorte.nombreEmpresa + "\n", "", fontL);

    sunmiInnerPrinter.setAlignment(0);
    sunmiInnerPrinter.printTextWithFont("Usuario: " + detCorte.nombreUsuario + "\n", "", fontM);
    sunmiInnerPrinter.printTextWithFont("APERTURA: " + detCorte.fecIniFondo + "\n", "", fontS);
    sunmiInnerPrinter.printTextWithFont("CIERRE: " + detCorte.fecFinFondo + "\n", "", fontS);
    
    sunmiInnerPrinter.setAlignment(0);
    sunmiInnerPrinter.printTextWithFont("FONDO DE CAJA " + accounting.formatMoney(detCorte.montoFondo, "Q")+ "\n", "", fontM);
    sunmiInnerPrinter.printTextWithFont("VALES         " + accounting.formatMoney(detCorte.totalVales, "Q") + "\n", "", fontM);

    sunmiInnerPrinter.printTextWithFont("VISA          " + accounting.formatMoney(detCorte.totalVisa, "Q") + "\n", "", fontM);
    sunmiInnerPrinter.printTextWithFont("CREDOMATIC    " + accounting.formatMoney(detCorte.totalBac, "Q") + "\n", "", fontM);
    sunmiInnerPrinter.printTextWithFont("EFECTIVO      " + accounting.formatMoney(detCorte.totalEfectivoQ, "Q") + "\n\n", "", fontM);

    sunmiInnerPrinter.printTextWithFont("VENTA NETA " + accounting.formatMoney(detCorte.totalVentas, "Q") + "\n\n", "", fontL);
    let dif = accounting.formatNumber(detCorte.diferencia, 2);
    if(dif > 0){
        sunmiInnerPrinter.printTextWithFont("DIFERENCIA    " + accounting.formatMoney(detCorte.diferencia, "Q") + "\n\n", "", fontM);
    } 

    sunmiInnerPrinter.setAlignment(1);
    sunmiInnerPrinter.printTextWithFont("- DETALLE POR PRODUCTO -\n", "", fontM);
    
    var texto = ["Descripcion", "Cant.", "Total"];
    sunmiInnerPrinter.printColumnsText(texto, tamano, alineamiento);

    $.each(detVentas, function(index, val){
        let producto = [val.nombre + " - " + val.sku, parseFloat(val.cant), "Q"+ val.total];
        sunmiInnerPrinter.printColumnsText(producto, tamano, alineamiento);
    });

    sunmiInnerPrinter.setAlignment(1);
    sunmiInnerPrinter.printTextWithFont(`${prntlinea}\n`, "", fontL);

    sunmiInnerPrinter.commitPrinterBuffer();
    sunmiInnerPrinter.exitPrinterBuffer(true);

    sunmiInnerPrinter.cutPaper();
    
    Swal.fire({
        title: '&iquest;Desea Continuar?',
        icon: 'question',
        showCancelButton: true,
        showCloseButton: false,
        cancelButtonText: 'Cerrar Sesi&oacute;n',
        confirmButtonColor: '#3085d6',
        confirmButtonText: 'Si, Continuar',
        allowOutsideClick: false,
        allowEscapeKey: false,
    }).then((result) => {
        
        if (result.value) {
            window.location = "main.html";
        }
        else{
            salirCaja();
        }

    });

    $('#loader').hide();
}