function nitIsValid(nit) {
    if (!nit) {
        return true;
    }

    let nitRegExp = new RegExp('^[0-9]+(-?[0-9kK])?$');

    if (!nitRegExp.test(nit)) {
        return false;
    }

    nit = nit.replace(/-/, '');
    let lastChar = nit.length - 1;
    let number = nit.substring(0, lastChar);
    let expectedCheker = nit.substring(lastChar, lastChar + 1).toLowerCase();

    let factor = number.length + 1;
    let total = 0;

    for (var i = 0; i < number.length; i++) {
        let character = number.substring(i, i + 1);
        let digit = parseInt(character, 10);

        total += (digit * factor);
        factor = factor - 1;
    }

    let modulus = (11 - (total % 11)) % 11;
    let computedChecker = (modulus == 10 ? "k" : modulus.toString());

    return expectedCheker === computedChecker;
}

function validarNIT(){
    var $this = $("#nit");
    var nit = $this.val();
  
    if (nit && nitIsValid(nit)) {
        $this.removeClass('invalid');
        $this.addClass('valid');
        consultaNIT();
    } else if (nit) {
        $this.removeClass('valid');
        $this.addClass('invalid');
        $('#nombre').val('');
        $('#direccion').val('');
    } else {
        $this.removeClass('valid');
        $this.removeClass('invalid');
        $('#nombre').val('');
        $('#direccion').val('');
    }
  }

function createNumPad(parent, inputElement, opt1, opt2, opt3){
    let optHtml = [];
    let optarr = [opt1, opt2, opt3];

    optarr.forEach(function(item) {
        switch(item){
            case 'arrow-up':
                optHtml.push(`<a class="waves-effect waves-light btn-large  amber darken-2 btn-icon keyArrow"
                onclick="fnArrow(this,'${inputElement}');" data-valor='UP'>
                <i class="material-icons right">keyboard_arrow_up</i></a>`); 
                break;
            case 'arrow-down':
                optHtml.push(`<a class="waves-effect waves-light btn-large  amber darken-2 btn-icon keyArrow"
                onclick="fnArrow(this,'${inputElement}');" data-valor='DOWN'>
                <i class="material-icons right">keyboard_arrow_down</i></a>`);
                break;
            case 'confirm':
                optHtml.push(`<a class="waves-effect waves-light btn-large  amber darken-2 btn-icon "
                onclick="fnConfirm(this, '${inputElement}');" data-valor='intro'>
                <i class="material-icons right">keyboard_return</i></a>`);
                break;
            case '':
                optHtml.push(`<a class="btn-large btn-icon disabled"></a>`);
                break;
            default:
                optHtml.push(`<a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='${item}'">${item}</a>`);
                
                break;
        }
    });

    let teclado = `
            <div class="col-num col s12 center">
                <a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='7'>7</a>

                <a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='8'>8</a>
                
                <a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='9'>9</a>
                
                <a class="waves-effect waves-light btn-large blue-grey darken-4 btn-icon keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='backspace'><i class="material-icons right">backspace</i></a>
            </div>

            <div class="col-num col s12 center">
                <a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='4'>4</a>

                <a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='5'>5</a>

                <a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='6'>6</a>

                <a class="waves-effect waves-light btn-large blue-grey darken-4 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='clear'>C</a>
            </div>
        
            <div class="col-num col s12 center">
                <a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='1'>1</a>

                <a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='2'>2</a>

                <a class="waves-effect waves-light btn-large blue-grey darken-1 btn-num keyPad"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='3'>3</a>
                ${optHtml[1]}
            </div>
        
            <div class="col-num col s12 center">
                <a class="waves-effect waves-light btn-large blue-grey darken-1  keyPad"
                style="width: 146.90px; border-radius: 15px; font-weight: bold; font-size: 2.5em; margin: 0em 0.1em; line-height: 65px; height: 70px;"
                onclick="insertNumPad(this,'${inputElement}');" data-valor='0'>0</a>
                ${optHtml[0]}
                ${optHtml[2]}
            </div>`

    $('#' + parent).html(teclado);
}

function insertNumPad(sender, target){
    let actual = $("#"+target).val();
    let digit = $(sender).data('valor');

    switch(digit){
        case 'clear':
        $("#"+target).val("");
        break;
        case 'backspace':
        $("#"+target).val(actual.slice(0, -1));
        break;
        case '.':
        if(actual.indexOf(".") == -1){
            if(actual == ""){
            $("#"+target).val("0.");
            } else {
            $("#"+target).val("" + actual + digit);
            }
        }
        break;
        default:
        $("#"+target).val("" + actual + digit);
        break;
    }

    switch(target){
        case 'nit':
            validarNIT();
            break;
        default:
            $('#' + target).trigger('change');
            break;
    }
}

function fnArrow(sender, target){
    let iTarget = $('#'+ target).data('index');
    let idPreFix = target.replace(iTarget, '');
    let direction = $(sender).data('valor');
    let nTarget;


    switch(direction){
        case 'UP':
            nTarget = iTarget -1;
            nTarget = (nTarget < 0)? 0 : nTarget;
            break;
        case 'DOWN':
            nTarget = iTarget +1;
            nTarget = ($('#' + idPreFix + nTarget).length)? nTarget : iTarget;
            break;
        default:
            break;
    }

    if(iTarget != nTarget){
        $('#' + target).css('border-bottom-color', '#9e9e9e');
        $('#' + target).css('background-color', 'transparent');
        
        $('#' + idPreFix + nTarget).css('border-bottom-color', '#ffb300');
        $('#' + idPreFix + nTarget).css('background', '#ffecb3');
        
        $('.keyPad').attr("onclick","insertNumPad(this,'" + idPreFix + nTarget  + "');");
        $('.keyArrow').attr("onclick","fnArrow(this,'" + idPreFix + nTarget  + "');");
    }



}

function fnConfirm(sender, idPassword){
    $('#loader').show();
  
    var usuario = localStorage.codigoUsuario;
    var pwd = $("#" + idPassword).val();
  
    if (usuario == undefined){
        salirCaja();
    }
  
    if (pwd == '') {
        $('#loader').hide();
        Swal.fire({
            icon: 'warning',
            text: 'Debe ingresar su contrase&#241;a',
            showCloseButton: true,
            confirmButtonText: 'Intentar de nuevo',
            html: 'Debe ingresar su contrase&#241;a'
        });
  
    } else {
        
        params = {
            service: 'login',
            dbName: dbName,
            usuario: usuario,
            password: pwd
        };
        $.post(host, params, function(data) {
            if (data !== null) {
                confirmado();
            } else {
                $("#" + idPassword).val("");
                $('#loader').hide();
                Swal.fire({
                    icon: 'error',
                    text: 'Contrase&#241;a incorrecta',
                    showCloseButton: true,
                    confirmButtonText: 'Intentar de nuevo',
                    html: 'Contrase&#241;a incorrecta'
                });
            }
        }, 'json');
    }
  }

  function salirCaja() {
    localStorage.codigoUsuario = undefined;
    localStorage.idUsuarios = undefined;
    localStorage.nombreUsuario = undefined;
    localStorage.tipoUsuario = undefined;
    localStorage.idSucursales = undefined;
    localStorage.idEmpresas = undefined;
    window.location = "index.html";
}
